function Dph = Delta_ph(F,D,Dph0,q,q_ph)
% Newtons method for finding Dph with 'decacc' decimal accuracy
% Here F refers to the square root fidelity
if D>0.1101; Dph = 0.5; return; end
F = real(F); decacc = 9;
if F>1-10^(-(decacc+3)); Dph = D; return; end % if F==1; Dph = D;
% if F==1; Dph = D; return; end
if F^2<0.5 || D>=0.5; Dph = 0.5; return; end
if Dph0<1; Dph = Dph0; % Try start at previous Dph
else Dph = 1-F^2 + 2*D; % Starting at the right side of F=1
    if Dph>1; Dph = 1; end % Dph <= 1
end
sD = sqrt(D); s1D = sqrt(1-D);

if nargin == 3; s1M=0; sM=1; % Koashi
else % Mary
    if nargin == 4; q_ph = q; end;
    if F<=1+q_ph*(sqrt(0.5)-1); Dph = 0.5; return; end %  for +KGR
    s1M = sqrt((1-q)*(1-q_ph)); sM = sqrt(q*q_ph);
end
if (sD*sM+s1M)>=F; Dph = 0.5; return; end % No solution for Dph

i = 0; acc = 1; max = decacc*1000;
while (i<max && acc); i = i+1;
    if Dph < D; Dph = 2*D-Dph; end
    G = s1D*sM*sqrt(1-Dph) + sD*sM*sqrt(Dph) + s1M - F;
    dG = 0.5*sM*(-s1D/sqrt(1-Dph) + sD/sqrt(Dph));
    Dph = Dph - (G/dG);
    if isnan(G/dG); error('Not a number appeared'); end
    % Stop if its accurate to the 'decacc'th decimal
    acc = 0 ~= round(10^decacc*G/dG);
end

Dph = abs(Dph);
% If we cannot guarantie correct solution: abort.
if i==max; error('Loop reached maximum allowed iterations');end
if isnan(Dph); error('Not a number appeared');end
if Dph<D; error('Chose lower solution');end