clc
format compact

load('dataUD_A0_0001_2_Nvar_dC1_qC5_K025_05_1_2_q02_02_04_02');
% load('dataUD_A0_0001_2_N8_K025_05_1_2_q02_02_04_02');
u = exp(-A.^2);
p = 1 - u;
Am = A(1:1000);
L = length(Am);
Rn = zeros(L,1); Rd = zeros(L,1); Ru = zeros(L,1);
RdR = zeros(L,1); RuR = zeros(L,1); % Random fluct
RdA = zeros(L,1); RuA = zeros(L,1); % Announced fluct
QBER = 0.0;

% K = [0 0.5 1 2]; % Relative amplitudes for fluctating case
% q = [0.2 0.2 0.4 0.2]; % Their probabilities
K = [0.25 0.5 1 2]; % Relative amplitudes for fluctating case
q = [0.2 0.2 0.4 0.2]; % Their probabilities
Kavg = sqrt(sum(q.*K.^2)); % to give same average photon number
K = K/Kavg;
K1 = K(1); K2 = K(2); K3 = K(3); K4 = K(4);
q1 = q(1); q2 = q(2); q3 = q(3); q4 = q(4);

for j=1:L
    Rn(j) = keyGenRate(NonRanPhase(j),A(j),QBER,'K');
    Ru(j) = keyGenRate(Fu(j),A(j),QBER,'K');
    RdR(j) = keyGenRate(FdR(j),A(j),QBER,'K');
    RuR(j) = keyGenRate(FuR(j),A(j),QBER,'K');
    
    j1 = findIndex(K1*A(j)); j2 = findIndex(K2*A(j));
    j3 = findIndex(K3*A(j)); j4 = findIndex(K4*A(j));
    
    RdA(j) = q1*p(j1)*keyGenRate(NonRanPhase(j1),A(j1),QBER,'K') ...
           + q2*p(j2)*keyGenRate(NonRanPhase(j2),A(j2),QBER,'K') ...
           + q3*p(j3)*keyGenRate(NonRanPhase(j3),A(j3),QBER,'K') ...
           + q4*p(j4)*keyGenRate(NonRanPhase(j4),A(j4),QBER,'K');
    RdA(j) = RdA(j)/(q1*p(j1)+q2*p(j2)+q3*p(j3)+q4*p(j4));
    
    RuA(j) = q1*p(j1)*keyGenRate(Fu(j1),A(j1),QBER,'K') ...
           + q2*p(j2)*keyGenRate(Fu(j2),A(j2),QBER,'K') ...
           + q3*p(j3)*keyGenRate(Fu(j3),A(j3),QBER,'K') ...
           + q4*p(j4)*keyGenRate(Fu(j4),A(j4),QBER,'K');
    RuA(j) = RuA(j)/(q1*p(j1)+q2*p(j2)+q3*p(j3)+q4*p(j4));
end
figure(8)
hold on
plot(Am,Rn,'-','Color',[0.5 0 0],'LineWidth',4)
plot(Am,Ru,'-','Color',[0 0 0.5],'LineWidth',4)
plot(Am,RdR,'--','Color','r','LineWidth',4)
plot(Am,RuR,'--','Color','b','LineWidth',4)
plot(Am,RdA,'-','Color',[1 0.3 0],'LineWidth',4)
plot(Am,RuA,'--','Color',[0 1 0.3],'LineWidth',4)
XLIM([0 length(Am)/1000])
xlabel('\alpha')
ylabel('R_{0,K}')
hold off

for j=1:L
    Rn(j) = keyGenRate(NonRanPhase(j),A(j),QBER,'M');
    Ru(j) = keyGenRate(Fu(j),A(j),QBER,'M');
    RdR(j) = keyGenRate(FdR(j),A(j),QBER,'M');
    RuR(j) = keyGenRate(FuR(j),A(j),QBER,'M');
        
    j1 = findIndex(K1*A(j)); j2 = findIndex(K2*A(j));
    j3 = findIndex(K3*A(j)); j4 = findIndex(K4*A(j));
    RdA(j) = q1*p(j1)*keyGenRate(NonRanPhase(j1),A(j1),QBER,'M') ...
           + q2*p(j2)*keyGenRate(NonRanPhase(j2),A(j2),QBER,'M') ...
           + q3*p(j3)*keyGenRate(NonRanPhase(j3),A(j3),QBER,'M') ...
           + q4*p(j4)*keyGenRate(NonRanPhase(j4),A(j4),QBER,'M');
    RdA(j) = RdA(j)/(q1*p(j1)+q2*p(j2)+q3*p(j3)+q4*p(j4));
    RuA(j) = q1*p(j1)*keyGenRate(Fu(j1),A(j1),QBER,'M') ...
           + q2*p(j2)*keyGenRate(Fu(j2),A(j2),QBER,'M') ...
           + q3*p(j3)*keyGenRate(Fu(j3),A(j3),QBER,'M') ...
           + q4*p(j4)*keyGenRate(Fu(j4),A(j4),QBER,'M');
    RuA(j) = RuA(j)/(q1*p(j1)+q2*p(j2)+q3*p(j3)+q4*p(j4));
end
figure(9)
hold on
plot(Am,Rn,'-','Color',[0.6 0 0],'LineWidth',4)
plot(Am,Ru,'-','Color',[0 0 0.6],'LineWidth',4)
plot(Am,RdR,'--','Color','r','LineWidth',4)
plot(Am,RuR,'--','Color','b','LineWidth',4)
plot(Am,RdA,'-','Color',[1 0.3 0],'LineWidth',4)
plot(Am,RuA,'--','Color',[0 1 0.3],'LineWidth',4)
XLIM([0 length(Am)/1000])
xlabel('\alpha')
ylabel('R_{0,M}')
hold off