clc
format compact

load('dataUD_A0_0001_2_B05A_Nvar_Ran_vs_Det');

load('dataUD_A0_0001_2_Nvar_dC1_qC5_K025_05_1_2_q02_02_04_02');

Pe = 8.5*10^(-7); nB = 0.045;

dist = [0:1:30 31:0.1:40 40.1:0.02:42 42.1:0.1:49 49.1:0.02:51 55];
L = length(dist);
Rn = zeros(L,1); Ru = zeros(L,1);
RdR = zeros(L,1); RuR = zeros(L,1); % Random fluct
RdA = zeros(L,1); RuA = zeros(L,1); % Announced fluct
An = zeros(L,1); Au = zeros(L,1);
AdR = zeros(L,1); AuR = zeros(L,1); % Random fluct
AdA = zeros(L,1); AuA = zeros(L,1); % Announced fluct
parfor j=1:L
    [RnMax RuMax RdRMax RuRMax RdAMax RuAMax, ...
    An(j) Au(j) AdR(j) AuR(j) AdA(j) AuA(j)] = ...
    keyRateDist(Pe,nB,dist(j));

    Rn(j) = log10(RnMax);
    Ru(j) = log10(RuMax);
    RdR(j) = log10(RdRMax);
    RuR(j) = log10(RuRMax);
    RdA(j) = log10(RdAMax);
    RuA(j) = log10(RuAMax);
end

figure(9)
hold on
plot(dist,Rn,'-','Color',[0.5 0 0],'LineWidth',4)
plot(dist,Ru,'-','Color',[0 0 0.5],'LineWidth',4)
plot(dist,RdR,'--','Color','r','LineWidth',4)
plot(dist,RuR,'--','Color','b','LineWidth',4)
plot(dist,RdA,'-','Color',[1 0.3 0],'LineWidth',4)
plot(dist,RuA,'--','Color',[0 1 0.3],'LineWidth',4)
xlabel('Distance [km]')
ylabel('log(R_{0,M})')
set(gca,'XTick',0:5:55)
XLIM([0 55])
set(gca,'YTick',-20:1:-5)
hold off

figure(91)
hold on
plot(dist,2.*abs((An-1)/1000).^2,'-','Color',[0.5 0 0],'LineWidth',4)
plot(dist,2.*abs((Au-1)/1000).^2,'-','Color',[0 0 0.5],'LineWidth',4)
plot(dist,2.*abs((AdR-1)/1000).^2,'--','Color','r','LineWidth',4)
plot(dist,2.*abs((AuR-1)/1000).^2,'--','Color','b','LineWidth',4)
plot(dist,2.*abs((AdA-1)/1000).^2,'-','Color',[1 0.3 0],'LineWidth',4)
plot(dist,2.*abs((AuA-1)/1000).^2,'--','Color',[0 1 0.3],'LineWidth',4)
xlabel('Distance [km]')
ylabel('log(\mu)')
set(gca,'XTick',0:5:55)
XLIM([0 55])
YLIM([0 0.27])
set(gca,'YTick',0:0.01:0.27)
hold off