function [PxuS,PyuS,PxdS,PydS] = createDataSet(A,B,N,K,q)
%createDataSet(A,B,N,K,q) creates data set for fluctuating
%fidelity with K as the relative amplitude konstants and q are
%the probabilities

Lq = length(q); N2 = 2*N^2; zerosN2 = zeros(N2,N2);
PxuS = zerosN2; PyuS = zerosN2; PxdS = zerosN2; PydS = zerosN2;
parfor j = 1:Lq %parallel computing
    % uniform phase distribution
    [Pxu,Pyu] = rhoxyU(K(j)*A,K(j)*B,N);
    PxuS = PxuS + q(j)*Pxu;
    PyuS = PyuS + q(j)*Pyu;
    % non-random (determined) phase
    [Pxd,Pyd] = rhoxyD(K(j)*A,K(j)*B,N);
    PxdS = PxdS + q(j)*Pxd;
    PydS = PydS + q(j)*Pyd;
end