format compact
%For creating data set and save it to file
load('dataUD_A0_0001_2_Nvar_dC1_qC5_K025_05_1_2_q02_02_04_02')
N = 8; % Calculation size, proportional to 2*N^4.
A = 0:0.001:2; % Signal pulse photon number mean value u=2A^2
B = A; % Reference pulse photon number mean value u=2B^2
K = [0.25 0.5 1 2]; % Relative amplitudes for fluctating case
q = [0.2 0.2 0.4 0.2]; % Their probabilities
Kavg = sqrt(sum(q.*K.^2)); % to give same average photon number
K = K/Kavg;
qC = 5; dC = 1; % q and d in cosine distribution

L = length(A); Lq = length(q);
zerosN2 = zeros(N2,N2); Ns = zeros(1,length(A));

FuR = zeros(L,1); FdR = zeros(L,1);
tuR = ones(L,1); tdR = ones(L,1);
Fu = zeros(L,1); Fd = zeros(L,1); Fc = zeros(L,1);
tu = ones(L,1); td = ones(L,1); tc = ones(L,1);
NonRanPhase = zeros(L,1);

progress = 0 %#ok<NOPTS>
tStart = tic;
for p = 1:L
    % Analytical solution for non-random phase
    NonRanPhase(p) = abs(cos(A(p)^2)+sin(A(p)^2))*exp(-A(p)^2);
    % Uniform phase distribution
    [Pxu,Pyu] = rhoxyU(A(p),B(p),N);
    Fu(p) = fidelity(Pxu,Pyu); % Fidelity
    tu(p) = min([trace(Pxu) trace(Pyu)]);
    % Cosine distributed phase
    [Pxc,Pyc] = rhoxyC(dC,qC,A(p),B(p),N);
    Fc(p) = fidelity(Pxc,Pyc); % Fidelity
    tc(p) = min([trace(Pxc) trace(Pyc)]);
    
    % Fluctuating case: u for uniform d for determined
    [PxuS,PyuS,PxdS,PydS] = createDataSet(A(p),B(p),N,K,q);
    % Uniform distributed phase
    FuR(p) = fidelity(PxuS,PyuS); % Fidelity
    tuR(p) = min([trace(PxuS) trace(PyuS)]);
    % Non-random phase
    FdR(p) = fidelity(PxdS,PydS); % Fidelity
    tdR(p) = min([trace(PxdS) trace(PydS)]);
    
    Ns(p) = N; % Log the Ns used
	if min([tu(p) td(p) tuR(p) tdR(p) tc(p)]) <= 0.999999 && N<16;
        N = N+2; end; % Increase calculation size when needed
    
    clc
    N %#ok<NOPTS>
    progress = p/L %#ok<NOPTS>
    SecondsElapsed = toc(tStart);
    timeElapsed = MinutesSeconds(SecondsElapsed) %#ok<NOPTS>
    timeRemaining = MinutesSeconds((1-progress)*SecondsElapsed/progress) %#ok<NOPTS> % time in minutes
end
save('dataUD_A0_0001_2_Nvar_dC1_qC5_K025_05_1_2_q02_02_04_02', ...
    'A','B','Fu','Fd','Fc','FuR','FdR','NonRanPhase','Ns')
abeep;