function [RnMax RuMax RdRMax RuRMax RdAMax RuAMax, ...
    An Au AdR AuR AdA AuA] = keyRateDist(Pe,nB,dist)

load('dataUD_A0_0001_2_Nvar_dC1_qC5_K025_05_1_2_q02_02_04_02');

Am = A(1:round(length(A)/2));
L = length(Am);
Rn = zeros(L,1); Ru = zeros(L,1);
RdR = zeros(L,1); RuR = zeros(L,1); % Random fluct
RdA = zeros(L,1); RuA = zeros(L,1); % Announced fluct
Dphn = ones(L+1,1); Dphu = ones(L+1,1);
DphdR = ones(L+1,1); DphuR = ones(L+1,1); % Random fluct
DphdA1 = ones(L+1,1); DphuA1 = ones(L+1,1); % Announced fluct
DphdA2 = ones(L+1,1); DphuA2 = ones(L+1,1); % Announced fluct
DphdA3 = ones(L+1,1); DphuA3 = ones(L+1,1); % Announced fluct
DphdA4 = ones(L+1,1); DphuA4 = ones(L+1,1); % Announced fluct

K = [0.25 0.5 1 2]; % Relative amplitudes for fluctating case
q = [0.2 0.2 0.4 0.2]; % Their probabilities
Kavg = sqrt(sum(q.*K.^2)); % to give same average photon number
K = K/Kavg;
K1 = K(1); K2 = K(2); K3 = K(3); K4 = K(4);
q1 = q(1); q2 = q(2); q3 = q(3); q4 = q(4);

for j=1:L
    [Rn(j) Dphn(j+1)] = ...
        uKeyGenRate(NonRanPhase(j),A(j),Pe,nB,dist,Dphn(j));
    [Ru(j) Dphu(j+1)] = ...
        uKeyGenRate(Fu(j),A(j),Pe,nB,dist,Dphu(j));
    [RdR(j) DphdR(j+1)] = ...
        uKeyGenRate(FdR(j),A(j),Pe,nB,dist,DphdR(j));
    [RuR(j) DphuR(j+1)] = ...
        uKeyGenRate(FuR(j),A(j),Pe,nB,dist,DphuR(j));
    
    j1 = findIndex(K1*A(j)); j2 = findIndex(K2*A(j));
    j3 = findIndex(K3*A(j)); j4 = findIndex(K4*A(j));
    [RdA1 DphdA1(j+1)] = ...
      uKeyGenRate(NonRanPhase(j1),A(j1),Pe,nB,dist,DphdA1(j));
    [RdA2 DphdA2(j+1)] = ...
     uKeyGenRate(NonRanPhase(j2),A(j2),Pe,nB,dist,DphdA2(j));
    [RdA3 DphdA3(j+1)] = ...
     uKeyGenRate(NonRanPhase(j3),A(j3),Pe,nB,dist,DphdA3(j));
    [RdA4 DphdA4(j+1)] = ...
     uKeyGenRate(NonRanPhase(j4),A(j4),Pe,nB,dist,DphdA4(j));
    RdA(j) = q1*RdA1 + q2*RdA2 + q3*RdA3 + q4*RdA4;
    [RuA1 DphuA1(j+1)] = ...
     uKeyGenRate(Fu(j1),A(j1),Pe,nB,dist,DphuA1(j));
    [RuA2 DphuA2(j+1)] = ...
     uKeyGenRate(Fu(j2),A(j2),Pe,nB,dist,DphuA2(j));
    [RuA3 DphuA3(j+1)] = ...
     uKeyGenRate(Fu(j3),A(j3),Pe,nB,dist,DphuA3(j));
    [RuA4 DphuA4(j+1)] = ...
     uKeyGenRate(Fu(j4),A(j4),Pe,nB,dist,DphuA4(j));
    RuA(j) = q1*RuA1 + q2*RuA2 + q3*RuA3 + q4*RuA4;
end
[RnMax An] = max(Rn); [RuMax Au] = max(Ru);
[RdRMax AdR] = max(RdR); [RuRMax AuR] = max(RuR);
[RdAMax AdA] = max(RdA); [RuAMax AuA] = max(RuA);

%-------------------------
function [R_0 delta_ph] = uKeyGenRate(F,A,Pe,nB,dist,Dph0)
u = (A^2)*10^(-0.02*dist);
QBER = 0.5*Pe/(0.5*u*nB + Pe);
delta_0 = QBER;
delta_1 = QBER;
q_ph = 1-exp(-u); % Probability of nonvacuum event

delta_ph = Delta_ph(F,delta_1,Dph0,q_ph,q_ph);

R_0 = 1 - H(min(0.5, delta_ph)) - H(delta_0);
R_0 = nB*q_ph*max(real(R_0),0);

