function [Px,Py] = rhoxyU(A,B,N)
%rhoxyU(A,B,N) produses the X and Y density matrices for uniform
%phase distribution. A and B are signal and reference amplitude,
%N is cacluation size.

I = [1 0; 0 1]; X = [0 1; 1 0];
Y = [0 -1i; 1i 0]; Z = [1 0; 0 -1]; %Pauli matrices

Px = kron(I+X,DensityMsU(1,1,A,B,N)) ...
   + kron(Z-1i*Y,DensityMsU(1,-1,A,B,N)) ...
   + kron(Z+1i*Y,DensityMsU(-1,1,A,B,N)) ...
   + kron(I-X,DensityMsU(-1,-1,A,B,N));

Py = kron(I+Y,DensityMsU(-1i,-1i,A,B,N)) ...
   + kron(Z+1i*X,DensityMsU(-1i,1i,A,B,N)) ...
   + kron(Z-1i*X,DensityMsU(1i,-1i,A,B,N)) ...
   + kron(I-Y,DensityMsU(1i,1i,A,B,N));

%-------------------------
function DMU = DensityMsU(c1,c2,A,B,N)
DMU = zeros(N*N,N*N);
parfor k = 0:N-1 %parallel computing
  for l = 0:N-1
    PmnV = zeros(N,N);
    for m = 0:N-1
      if (k-l+m)>=0 && (k-l+m)<N
        PmnV = PmnV + Pmn(B,m,k-l+m,N);
      end
    end
    DMU = DMU + kron(Pkl(c1,c2,A,k,l,N),PmnV);
  end
end
DMU = 0.25*exp(-(A^2)-(B^2)).*DMU;